#ifndef __PTZ_STRUCT_H_
#define __PTZ_STRUCT_H_
#include "sock_utils.h"
#include "ptz_type_select.h"
#include "tmc2160.h"
#include "rotate_electricstable.h"

///ע
///_setʾʵ趨Ĳ_actualʾʵʲ,_stateʾ״̬
///_lastʾһεĲ_planʾ滮,_numʾ_countʾ
///_controlʾֵ
typedef struct _PtzRotatePlan_ 
{
  float max_speed;//ת
  float start_angle;//ʼ
  float stop_angle;//
  float stop_near_angle;//ɲ
  float stop_far_angle; //ɲԶ
  float stop_angle_range;//ɲΧstop_near_anglestop_far_angle֮ľԾ
  float accelerate_end_angle;//ٽ
  float decelerate_start_angle;//ʼ
  char  direction;//
  float accelerate_angle_range;//ʼͼٽ֮ľֵ
  float decelerate_angle_range;//ٵֹͣλ֮ľֵ
  float uniform_angle_range;  //˶ľֵ
  float total_rotate_range;    //Ҫתܵľ
  char  rotate_switch; //תأ1Ҫת0Ҫת
}PtzRotatePlan;


///̨ǶȲ
typedef struct _PtzAngleParameter_ 
{
  float angle_min;//̨ǶСֵ
  float angle_max;//̨Ƕֵ
  float angle_allow_min;//̨ýǶСֵ
  float angle_allow_max;//̨ýǶֵ
  float angle_range;//̨ǶȷΧ
}PtzAngleParameter;


typedef struct _CameraLens_
{
  unsigned char foucs_state; //״̬  
  unsigned char zoom_state; //״̬
  
  float focus_v;//۽ѹ
  float focus_v_bit;//۽ѹԤλ
  unsigned char focus_g;    //۽ٶȵȼ
  unsigned char focus_pwm_on;//PWMʱms
  unsigned char focus_pwm_off;//PWMرʱms
  
  
  float zoom_v;//䱶ѹ
  float zoom_v_bit;//䱶ѹԤλ
  unsigned char zoom_g;//䱶ٶȵȼ
  unsigned char zoom_pwm_on;//PWMʱms
  unsigned char zoom_pwm_off;//PWMرʱms
  
}CameraLens;

#define CAMERA_LES_FOCUS_OFF    0//۽
#define CAMERA_LES_FOCUS_INC    1//۽
#define CAMERA_LES_FOCUS_RED    2//۽
#define CAMERA_LES_FOCUS_BIT    3//۽Ԥλ
#define CAMERA_LES_FOCUS_STOP   4//۽ͣ

#define CAMERA_LES_ZOOM_OFF     0//䱶
#define CAMERA_LES_ZOOM_INC     1//䱶
#define CAMERA_LES_ZOOM_RED     2//䱶
#define CAMERA_LES_ZOOM_BIT     3//䱶Ԥλ
#define CAMERA_LES_ZOOM_STOP    4//䱶ͣ


#define CAMERA_LES_FOCUS_FV_MAX  3.3  //ѹֵV
#define CAMERA_LES_FOCUS_FV_MIN  0    //ѹСֵV
#define CAMERA_LES_FOCUS_FV_BIT  0.06 //ԤλĿѹʵʵѹСֵ

#define CAMERA_LES_ZOOM_FV_MAX   3.3  //ѹֵV
#define CAMERA_LES_ZOOM_FV_MIN   0    //ѹСֵV
#define CAMERA_LES_ZOOM_FV_BIT   0.06 //ԤλĿѹʵʵѹСֵ

#define CAMERA_LES_FOCUS_T       20   //PWMٵms
#define CAMERA_LES_ZOOM_T        20   //PWMٵms

#define CAMERA_LES_V_NUM         5    //ѹɼ


typedef struct _PtzAs5047D_ 
{
  ///as5047d̨׼λóʼǶֵ
  float as5047d_ptz_init_angle;
  
  ///as5047dǶ̨Ƕֵ
  float as5047d_ptz_angle_max;
  
  ///űǶȻ̨ǶȶӦһκбK
  float as5047d_ptz_angle_K;
  
  ///as5047d̨ĽǶȵ˲Ƕȵǰֵ
  float as5047d_ptz_angle_wf_actual;
  
  ///as5047d̨ĽǶȵ˲Ƕһεֵ
  float as5047d_ptz_angle_wf_last;
  
  ///as5047d̨ĽǶȵǰʵֵ
  float as5047d_ptz_angle_actual;
  
  ///as5047d̨ĽǶһֵ
  float as5047d_ptz_angle_last;
  
  ///̨תΧӦĴűӦתܽǶȣ
  ///as5047d_ptz_angle_max = as5047d_cycle_num * 360 + as5047d_remain_angle
  ///as5047dתȦ⣬ĲȦĶ
  float as5047d_remain_angle;
  
  ///as5047dתȦֵ
  int as5047d_cycle_num;
  
  ///as5047dתȦתһȦӼ1
  int as5047d_cycle_count;
  int as5047d_cycle_count_last;
  //int as5047d_cycle_count_last_last;
  ///as5047dɼʵʱǶֵ
  float as5047d_angle_actual;
  
  ///as5047dת
  char as5047d_dir;
  
  ///as5047dݶ
  //unsigned int as5047d_read_error_count;
  
  ///as5047dɼһʵʱǶֵ
  float as5047d_angle_last;
  
  ///as5047dɼʵʱǶֵһʵʱǶֵĲֵ
  float as5047d_angle_difference;
  
  ///as5047d״̬,0Լʼ1 ܹʹã 0xff
  char as5047d_state;
  
  ///as5047dǷȫ,0 Ҫ 1
  char as5047d_data_reset;
  
  
  ///űת
  ///as5047dűת
  float as5047d_speed_actual;
  ///as5047dűתʼǶa
  float as5047d_speed_angle_a;
  ///as5047dűתٽǶb
  float as5047d_speed_angle_b;
  ///as5047dűתʼǶaǶb֮Ĳֵ
  float as5047d_speed_angle_c;
  ///as5047dűתʼǶaǶb֮һβֵ
  float as5047d_speed_angle_c_last;
  
  
  unsigned int time_now;
  unsigned int time_end;
  unsigned int time;
}PtzAs5047D;

//typedef struct _PtzJy02a_ 
//{
//  ///jy02aоƬصҪǼת
//  unsigned int jy02a_fg_num_actual;
//  unsigned int jy02a_fg_num_last;
//}PtzJy02a;

//оƬL6235D
typedef struct _PtzL6235d_ 
{
  char l6235d_hall_state_actual;//ǰĻ״̬ǰյĸ
  char l6235d_hall_state_last;//һλ״̬
  
  unsigned int l6235d_hall_h1_count;//
  unsigned int l6235d_hall_h2_count;
  unsigned int l6235d_hall_h3_count;
  unsigned int l6235d_hall_h123_count;//
  
  //unsigned int l6235d_satae_save_count;//洢
  //char l6235d_hall_state_save[L6235D_HALL_SAVE_NUM];//״̬
  
  char l6235d_motor_dir_actual;//ͨжϵĵʵת
}PtzL6235d;

///PIDв
typedef struct _PtzPidValue_
{
  char mode;//ٷʽѡ0ĬVREF٣pid٣1ɲPWMı䷴شС(ɲ)
  
  //ͨVREF٣PID
  float  SumError;//ۼ
  double KP;//
  double TI;//ֳ
  double TD;//΢ֳ
  float  LastError;//һƫ
  float  PrevError;//ϴƫ
  float  LastUT_float;//һPIDֵ
  float  T;//
  double A;//򻯲ABC
  double B;
  double C;
  float PidUT_float;//pidٵǰֵ
  unsigned int PidUT_uint;//pidٵǰֵ,
  
  //ͨPWMı䷴شС٣director
  unsigned int director_speed_vref;//ģѹȼ
  char director_speed_direction;//صٵķ
  unsigned short int director_speed_start_t; //ɲ
  unsigned short int director_speed_stop_t;//ɲ
  unsigned short int director_speed_t;//
  unsigned char director_speed_state;//صٵĹ
  
  unsigned int hall_h1_count;//
  unsigned int hall_h2_count;
  unsigned int hall_h3_count;
  unsigned int hall_h123_count;//
  
  unsigned int hall_h1_count_last;//ϴλ
  unsigned int hall_h2_count_last;
  unsigned int hall_h3_count_last;
  unsigned int hall_h123_count_last;
  
  unsigned int hall_h1_count_time;//ʱʱ
  unsigned int hall_h2_count_time;
  unsigned int hall_h3_count_time;
  unsigned int hall_h123_count_time;
  
  unsigned int hall_h1_count_time_s;//ʱʼʱ
  unsigned int hall_h2_count_time_s;
  unsigned int hall_h3_count_time_s;
  unsigned int hall_h123_count_time_s;
  
  unsigned int hall_h1_count_time_e;//ʱʱ
  unsigned int hall_h2_count_time_e;
  unsigned int hall_h3_count_time_e;
  unsigned int hall_h123_count_time_e;
  
  
  char hall_h1_start_flag;//ʱʼʱ
  char hall_h2_start_flag;//0ûյһ壬1Ѿյһ
  char hall_h3_start_flag;
  char hall_h123_start_flag;
  
  
  float hall_h1_motor_speed;//h1ĵת
  float hall_h2_motor_speed;//h2ĵת
  float hall_h3_motor_speed;//h3ĵת
  float hall_h123_motor_speed;//h3ĵת
  
  char roll_start; //ʼתı־0ûпʼת1ʼת
  
  //char srm;//ٷ0ֱߵ٣1PID١
  
}PtzPidValue;

///̨ϣ1ϣ0޹
typedef struct _FaultDetect_
{
  char vert_sw1_fault;//ֱSW1ع
  char vert_sw2_fault;//ֱSW2ع
  
  char hori_rotate_fault;//ˮƽת  
  char vert_rotate_fault;//ֱת
  char hori_hall_fault;//ˮƽ
  char vert_hall_fault;//ֱ
  
  char temperature_fault;//¶쳣
  char h_ntc_temp_fault;//¶쳣
  char v_ntc_temp_fault;//¶쳣
  
  char voltage_fault;//ѹ쳣
  char electric_current_fault;//쳣
  
  char Phase_curr_V;//ˮƽ
  char Phase_curr_H;//ֱ
  
  char fault;//ܱ־ֻҪйϾΪ1
}FaultDetect;

///ԴֵԴصԴ
typedef struct _AuxSwitchPower_
{
  char aux_switch_1;
  char aux_switch_2;
  char aux_switch_3;
  char aux_switch_4;
}AuxSwitchPower;


///̨0λƫƽǶ
typedef struct _PtzZeroOffsetAngle_ 
{
  
  float offset_anle;//ƫ
  
  float hori_zero_offset_angle;//̨ˮƽƫƽǶ
  float vert_zero_offset_angle;//̨ˮƽƫƽǶ
  char  hori_offset_switch;//ˮƽƫƿأ1ƫƣ0رգ2ƫݴ洢ȷƫƿ
  char  vert_offset_switch;//ֱƫƿأ1ƫƣ0رգ2ƫݴ洢ȷƫƿ
  unsigned int crc;//Ч
}PtzZeroOffsetAngle;

///̨Զ˿ڣյUDPԴIPַԴMACַ򱣴ָĶ˿ںIPϢ
typedef struct _PtzDebug_ 
{
  char open_switch;//Ƿ򿪷
  struct sockaddr_in data_from;//IPͶ˿
  socklen_t data_fromlen;//
}PtzDebug;


///λڴӡ
typedef struct _Ptzprintf_ 
{
  char net_udp_printf_switch;//Ƿ򿪣1򿪣0ر
  char uart_422_printf_switch;//Ƿ򿪣1򿪣0ر
  char uart_485_printf_switch;//Ƿ򿪣1򿪣0ر
  
  struct sockaddr_in printf_from;//IPͶ˿
  socklen_t printf_fromlen;//
}Ptzprintf;



///̨Ƕȶλش
typedef struct _PtzAngleLocation_ 
{
  char net_udp_location_switch;//Ƿ򿪣1򿪣0ر
  char uart_422_location_switch;//Ƿ򿪣1򿪣0ر
  char uart_485_location_switch;//Ƿ򿪣1򿪣0ر
  
  struct sockaddr_in hori_cmd_from;//IPͶ˿
  socklen_t hori_cmd_fromlen;//
  char hori_cmd;//1յˮƽǶȿָ,0δյˮƽǶȿָ
  unsigned char hori_angle[7];//洢յˮƽǶָ
  
  struct sockaddr_in vert_cmd_from;//IPͶ˿
  socklen_t vert_cmd_fromlen;//
  char vert_cmd;//1յֱǶȿָ,0δյֱǶȿָ
  unsigned char vert_angle[7];//洢յĴֱǶָ
}PtzAngleLocation;

///̨ɨ裬ɨһشɨ赽λش
typedef struct _PtzAreaScanEnd_ 
{
  char area_scan_end_udp_switch;//Ƿ,1򿪣0ر
  char area_scan_end_uart_422_switch;//Ƿ,1򿪣0ر
  char area_scan_end_uart_485_switch;//Ƿ,1򿪣0ر
  //char area_scan_cmd;//Ƿյɨָ
  
  char area_step_scan_location_udp_switch;//ɨ赽λش
  char area_step_scan_location_uart_422_switch;//ɨ赽λش
  char area_step_scan_location_uart_485_switch;//ɨ赽λش
  
  struct sockaddr_in area_scan_end_from;//IPͶ˿
  socklen_t area_scan_end_fromlen;//
  
  struct sockaddr_in area_step_scan_location_from;//IPͶ˿
  socklen_t area_step_scan_location_fromlen;//
}PtzAreaScanEnd;

///̨Ԥλλش
typedef struct _PtzPresetBit_ 
{
  //Ԥλɨ
  char preset_bit_scan_end_udp_switch;//Ƿ,1򿪣0ر
  char preset_bit_scan_end_uart_422_switch;//Ƿ,1򿪣0ر
  char preset_bit_scan_end_uart_485_switch;//Ƿ,1򿪣0ر
  //Ԥλɨ赽Ԥλ
  char preset_bit_scan_location_udp_switch;//Ƿ,1򿪣0ر
  char preset_bit_scan_location_uart_422_switch;//Ƿ,1򿪣0ر
  char preset_bit_scan_location_uart_485_switch;//Ƿ,1򿪣0ر
  //ͨԤλ
  char preset_bit_location_udp_switch;//Ƿ,1򿪣0ر
  char preset_bit_location_uart_422_switch;//Ƿ,1򿪣0ر
  char preset_bit_location_uart_485_switch;//Ƿ,1򿪣0ر
  char preset_bit_location_num;//λԤλ
  char preset_bit_location_cmd;//1յԤλָ2Ԥλˮƽλûֱλã3Ԥλˮƽλúʹֱλö0ûյԤλָ
  char preset_bit_location_cmd_source;//ָԴ
  
  struct sockaddr_in preset_bit_scan_end_from;//IPͶ˿
  socklen_t preset_bit_scan_end_fromlen;//
  
  struct sockaddr_in preset_bit_scan_location_from;//IPͶ˿
  socklen_t preset_bit_scan_location_fromlen;//
  
  struct sockaddr_in preset_bit_location_from;//IPͶ˿
  socklen_t preset_bit_location_fromlen;//
}PtzPresetBit;

//ָԴ
typedef struct _PtzCmdSave_ 
{
  unsigned char cmd_data[7];
  struct sockaddr_in cmd_from;//IPͶ˿
  socklen_t cmd_fromlen;//
  char cmd_data_flag; //ָ־1ʾչݣ0ʾûнչ
  
  char cmd_data_udp_flag;//UDPָ־1ʾչUDPݣ0ʾûнչUDP
  
  char cmd_dev;//ָԴͨ
}PtzCmdSave;







///ڴ洢̨ǰĹ״̬
///
///ڴ洢̨ǰĹ״̬
typedef struct _PtzState_ 
{
  ///ַ̨
  unsigned char address;
  ///̨ڲ
  int uart_422_baud;
  int uart_485_baud;
/******************************************/ 
#ifdef PTZ_BLDC_MOTOR  
  
  ///оƬl6235d
  PtzL6235d   hori_l6235d;
  PtzL6235d   vert_l6235d;
#endif
  
#ifdef  PTZ_STEP_MOTOR
  
#ifdef  DRV8711
  Drv8711Control hori_drv8711;
  Drv8711Control vert_drv8711;
#endif
  
#ifdef  TMC2160
  TMC2160Control hori_tmc2160;
  TMC2160Control vert_tmc2160;
#endif
  

  char hori_dec_mode;//ˮƽģʽ0Ϊ趨ʱ٣1Ĭʱ
  char vert_dec_mode;//ֱģʽ0Ϊ趨ʱ٣1Ĭʱ
#endif 
  
/*************************ˮƽת***********************/ 
  ///̨תƿ,ֵͬʾͬĿģʽΪ0ʱʾر
  ///1 ת 2 ת 3ǶȶλתָǶȣ4 ֹͣת
  char hori_rotate_monitor_switch;
  ///̨ˮƽǶ
  float hori_angle_set;
  float hori_angle_actual;
  float hori_angle_actual_a;//ʵʽǶ
  float hori_angle_last;
  float hori_angle_control;
  float hori_angle_right_inc_control;//ת,Ƕ
  float hori_angle_left_inc_control;//תǶ
  ///̨ˮƽͣ
  char  hori_start_stop_set;
  char  hori_start_stop_actual;
  ///̨ˮƽת
  char  hori_direction_set;
  char  hori_direction_actual;
  char  hori_direction_last;
  char  hori_direction_control;
  ///̨ˮƽת
  float hori_speed_set;
  float hori_speed_actual;
  float hori_speed_control;
  float hori_speed_as5047d_actual;//ݴų̋ת
  float hori_speed_jy02a_actual;//ݵоƬ̨ת
  float hori_speed_hall_actual;//ݵ̨ת
  ///̨ˮƽת
  float hori_motor_speed_set;
  float hori_motor_speed_actual;
  float hori_motor_speed_as5047d_actual;//ݴűĵת
  float hori_motor_speed_jy02a_actual;//ݵоƬĵת
  float hori_motor_speed_hall_actual;//ݵĵת
  
/*************************ֱת***********************/ 
  ///̨תƿ
  char vert_rotate_monitor_switch;
  ///ֱ̨Ƕ
  float vert_angle_set;
  float vert_angle_actual;//ʵʽǶ
  float vert_angle_actual_a;//ʵʽǶ
  float vert_angle_last;
  float vert_angle_control;
  ///ֱ̨ͣ
  char  vert_start_stop_set;
  char  vert_start_stop_actual;
  ///ֱ̨ת
  char  vert_direction_set;
  char  vert_direction_actual;
  char  vert_direction_last;
  char  vert_direction_control;
  ///ֱ̨ת
  float vert_speed_set;
  float vert_speed_actual;
  float vert_speed_control;
  float vert_speed_as5047d_actual;//ݴų̋ת
  float vert_speed_jy02a_actual;//ݵоƬ̨ת
  float vert_speed_hall_actual;//ݵ̨ת
  ///ֱ̨ת
  float vert_motor_speed_set;
  float vert_motor_speed_actual;
  float vert_motor_speed_as5047d_actual;//ݴűĵת
  float vert_motor_speed_jy02a_actual;//ݵоƬĵת
  float vert_motor_speed_hall_actual;//ݵĵת
  ///̨PIDٲ
  PtzPidValue vert_pid;
  PtzPidValue hori_pid;
  
/**********************λü⿪********************/ 
#ifdef PTZ_PHOTOELECTRIC_SWITCH    
  ///ˮƽƬ״̬,ڹ͵ƽδڹߵƽ
  char  hori_ps_sw3_state;
  ///ˮƽƬת½жϱ־1½жϣ0
  unsigned int  hori_ps_sw3_right_fall;
  ///ˮƽƬתжϱ־1жϣ0
  unsigned int  hori_ps_sw3_right_rise;
  ///ˮƽƬת½жϱ־1½жϣ0
  unsigned int  hori_ps_sw3_left_fall;
  ///ˮƽƬתжϱ־1жϣ0
  unsigned int  hori_ps_sw3_left_rise;
  ///ֱƬ״̬,ڹ͵ƽδڹߵƽ
  char  vert_ps_sw1_state;
  char  vert_ps_sw2_state;
  unsigned int  vert_ps_sw1_down_fall;
  unsigned int  vert_ps_sw1_up_rise;
  unsigned int  vert_ps_sw2_up_fall;
  unsigned int  vert_ps_sw2_down_rise;
  
#endif

  ///̨ˮƽת滮
  PtzRotatePlan hori_rotate_plan;
  ///ֱ̨ת滮
  PtzRotatePlan vert_rotate_plan;
  
  ///̨ˮƽԼ־,255ʾԼ
  unsigned char hori_self_check;
  ///ֱ̨Լ,255ʾԼ
  unsigned char vert_self_check;
  
  ///̨ˮƽű
  PtzAs5047D hori_as5047d;
  ///ֱ̨ű
  PtzAs5047D vert_as5047d; 
 
  ///̨ˮƽǶȷΧ
  PtzAngleParameter hori_angleP;
  ///ֱ̨ǶȷΧ
  PtzAngleParameter vert_angleP;
  
  ///̨תλǷ񵽴ָλ
  char hori_arrive_flag;//1תָλã0ָλ
  ///̨תλǷ񵽴ָλ
  char vert_arrive_flag;//1תָλã0ָλ
  
  ///ظλ
  char hori_repeat_locate_switch;//0Ҫظλ1Ҫظλ
  ///ظλ
  char vert_repeat_locate_switch;//0Ҫظλ1Ҫظλ
  
/******************************************/ 

  /*¶ȡѹ*/
  float H_boad_temp;//ˮƽ·¶
  float V_boad_temp;//ֱ·¶
  float temperature;
  float Voltage;
  float electric_current;
  ///ϼ
  FaultDetect fault_detect;
  
  ///ָظ
  char cmd_reply_switch;//1ظ򿪣0ظر
  
#ifdef PTZ_ELECTRIC_STABLE_L6235D
  ///ȶ
  ElectricStable hori_electric_stable;
  ElectricStable vert_electric_stable;
#endif
  ///ֵԴ
  AuxSwitchPower power;
  
  ///浱ǰյָ
  PtzCmdSave cmd_save;
 
  ///Ƕƫ
  PtzZeroOffsetAngle offset_angle;
  
  ///̨Զ˿
  PtzDebug debug_data;
  ///Ƕȶλش
  PtzAngleLocation location_return;
  ///ɨش
  PtzAreaScanEnd  area_scan_return; 
  ///Ԥλش
  PtzPresetBit preset_bit_return;
  
  //λڴӡ
  Ptzprintf ptz_printf;
  

  ///̵̨״̬
  unsigned char ptz_motor_relay_state;
  
  ///̨Լλݶȡ״̬
  unsigned char no_self_check_state; //0ȡ̨λòʧܣ1ȡλݳɹ2ȡԼݳɹλ
  
  ///̨ԼǿƱ
  unsigned char no_self_check_force_save; //0ǿƱ棬1ǿƱ
  ///ǿɾλ
  unsigned char no_self_check_force_erase; //0ǿɾ1ǿɾ
  
  ///Ԥָ濪
  char cmd_before_handle_swtich;//1Ԥָܲ棻0رԤָ
  
  ///ͷ
  CameraLens cameralens;
  
  
//  PtzWorkTime time;//̨ʱʱ
  
  unsigned char hori_angle_state;//Ƕ״̬0ϣ1
  unsigned char vert_angle_state;//Ƕ״̬0ϣ1
  
  unsigned char hori_angle_erro_switch;//ˮƽǶأʼڽǶģУ0رգ1
  
  float hori_angle_error;//洢ˮƽṹ
  
  /******/
  //űȦ쳣ͳ
  unsigned int hori_jia;//++
  unsigned int hori_jian;//--
  unsigned int hori_cuowu;//
  unsigned int vert_jia;//++
  unsigned int vert_jian;//--
  unsigned int vert_cuowu;//
  
  unsigned int vert_stop_num;
}PtzState;

extern PtzState g_ptz;

typedef struct _cycle_count_
{
  float intit;
  float actual;
  int count;
}cycle_count;
#endif